// C
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  Unit2, Unit3 ;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    SaveDialog1: TSaveDialog;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private 錾 }
	 procedure FileSave1(fn:String);
	 procedure FileSave2(fn:String);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// N
procedure TForm1.FormShow(Sender: TObject);
begin
	PicClear ;
	GCLS(Image1.Canvas,Image1.Width,Image1.Height);
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	PicClear ;
end;

// NA
procedure TForm1.Button1Click(Sender: TObject);
begin
	PicClear ;
	GCLS(Image1.Canvas,Image1.Width,Image1.Height);
end;

// 
procedure TForm1.Button2Click(Sender: TObject);
var
	i1,i2 : Integer ;
	x1,y1,x2,y2 : Integer ;
begin
   i1 := Random(8)+1;
   i2 := Random(5);
	x1 := Random(Image1.Width);
	x2 := Random(Image1.Width);
	y1 := Random(Image1.Height);
	y2 := Random(Image1.Height);
	PicAdd(1,i1,i2,x1,y1,x2,y2);
   GPEN (Image1.Canvas,0,i1,i2);
   GLINE(Image1.Canvas,0,x1,y1,x2,y2);
end;

// `
procedure TForm1.Button3Click(Sender: TObject);
var
	i1,i2 : Integer ;
	x1,y1,x2,y2 : Integer ;
begin
   i1 := Random(8)+1;
   i2 := Random(5);
	x1 := Random(Image1.Width);
	x2 := Random(Image1.Width);
	y1 := Random(Image1.Height);
	y2 := Random(Image1.Height);
	PicAdd(2,i1,i2,x1,y1,x2,y2);
   GPEN (Image1.Canvas,0,i1,i2);
   GBOX(Image1.Canvas,0,x1,y1,x2,y2);
end;

// ~
procedure TForm1.Button4Click(Sender: TObject);
var
	i1,i2 : Integer ;
	x1,y1,x2,y2 : Integer ;
begin
   i1 := Random(8)+1;
   i2 := Random(5);
	x1 := Random(Image1.Width);
	x2 := Random(Image1.Width);
	y1 := Random(Image1.Height);
	y2 := Random(Image1.Height);
	PicAdd(3,i1,i2,x1,y1,x2,y2);
   GPEN (Image1.Canvas,0,i1,i2);
   GCIRC(Image1.Canvas,0,x1,y1,x2,y2);
end;

// t@Cۑ
procedure TForm1.Button5Click(Sender: TObject);
var
	fn,ex : String ;
begin
	if (SaveDialog1.Execute) then begin
		fn := SaveDialog1.FileName ;
      if (ExtractFileExt(fn) = '') then begin
      	Case(SaveDialog1.FilterIndex)of
         1: fn := fn + '.bmp';
         2: fn := fn + '.emf';
         end;
      end;
		if (FileExists(fn)) then begin
			if MessageDlg('t@Cɑ݂܂B㏑Ă낵łH',
					mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
				exit;
         end;
      end;
      ex := AnsiUpperCase(ExtractFileExt(fn)) ;
      if (ex = '.BMP') then FileSave1(fn);
      if (ex = '.EMF') then FileSave2(fn);
	end;
end;

{ rbg}bvt@C̕ۑ }
procedure TForm1.FileSave1(fn:String);
var
	p : TBitmap ;
   px,py : Integer ;
begin
	if (Pic_N = 0) then begin
		MessageBeep(Word(-1));
		MessageDlg('ۑOɍ}sĉB',
      	 mtInformation,[mbOk], 0);
      exit;
   end;

	p := nil ;
	try
		p := TBitmap.Create ;
      px := Image1.Width ;
      py := Image1.Height ;
      p.Width  := px ;
      p.Height := py ;
      GALL(p.Canvas,0,px,py);
		p.SaveToFile(fn);
   	p.Free ;
   except
		if (p <> nil) then
      	p.Free ;
		if (FileExists(fn)) then
      	DeleteFile(fn);
   end;
end;

{ ^t@C̕ۑ }
procedure TForm1.FileSave2(fn:String);
var
	p : TMetafile ;
   px,py : Integer ;
begin
	if (Pic_N = 0) then begin
		MessageBeep(Word(-1));
		MessageDlg('ۑOɍ}sĉB',
      	 mtInformation,[mbOk], 0);
      exit;
   end;

   Button5.Enabled := False ;

	p := nil ;
	try
		p := TMetafile.Create ;
      px := Image1.Width ;
      py := Image1.Height ;
      GALL(nil,1,px,py);
      p.Handle := hmf ;
		p.SaveToFile(fn);
   	p.Free ;
	  	EMFEND;
   except
		if (p <> nil) then begin
      	p.Free ;
		  	EMFEND;
		end;
		if (FileExists(fn)) then
      	DeleteFile(fn);
   end;

   Button5.Enabled := True ;
end;

end.
