// OtBbN֘A
unit Unit2;

interface

uses
	Windows, Classes, SysUtils, Graphics,
   Unit3 ;

	procedure GCLS(C:TCanvas; px,py:Integer) ;
	procedure GPEN(C:TCanvas; mode,col,typ:Integer) ;
	procedure GLINE(C:TCanvas; mode,x1,y1,x2,y2:Integer);
	procedure GBOX (C:TCanvas; mode,x1,y1,x2,y2:Integer);
	procedure GCIRC(C:TCanvas; mode,x1,y1,x2,y2:Integer);
	procedure GALL (C:TCanvas; mode,px,py:Integer);
	procedure EMFEND ;

implementation

var
   hdcMeta, hdcRef: HDC;
	pen,hdrPrev : HPEN ;
	brsPrev : HBRUSH ;

{ ʃNA }
procedure GCLS(C:TCanvas;px,py:Integer) ;
begin
	with C do begin
      Pen.Mode  := pmCopy ;
      Pen.Width := 1 ;
      Pen.Color := clWhite ;
      Brush.Color := clWhite ;
      Brush.Style := bsSolid ;
      Rectangle(0,0,px,py);
		Brush.Style := bsClear ;
	end;
end;

{ y̐ݒ }
{		col : 0: 1: 2: 3: 4: 5: 6: 7: 8:D }
{		typ : 0: 1:j 2:aj 3:_ 4:_ }
procedure GPEN(C:TCanvas; mode,col,typ:Integer) ;
var
	i : LongInt ;
   j : Integer ;
begin
	Case (col) of
	1 : i := RGB(  0,  0,255) ;
   2 : i := RGB(255,  0,  0) ;
   3 : i := RGB(255,  0,255) ;
	4 : i := RGB(  0,255,  0) ;
   5 : i := RGB(  0,255,255) ;
   6 : i := RGB(255,255,  0) ;
   7 : i := RGB(  0,  0,  0) ;
   8 : i := RGB(127,127,127) ;
   else
   	 i := RGB(255,255,255) ;
   end;

	if (mode = 0) then begin
		with C do begin
			Pen.Color := i ;
			Case (typ) of
			1 : Pen.Style := psDash	;
     		2 : Pen.Style := psDot ;
			3 : Pen.Style := psDashDot ;
			4 : Pen.Style := psDashDotDot ;
			else
   	   	 Pen.Style := psSolid ;
			end;
		end;
	end
   else if (mode = 1) then begin
      DeleteObject(pen);
 		Case (typ) of
 		1 : j := PS_DASH	;
      2 : j := PS_DOT ;
		3 : j := PS_DASHDOT ;
      4 : j := PS_DASHDOTDOT ;
      else
   	  	 j := PS_SOLID ;
      end;
		pen := CreatePen(j,0,Cardinal(i));
		SelectObject(hdcMeta,pen);
   end;
end;

{ ` }
{		x1,y1 : Jn_ }
{		x2,y2 : I_ }
procedure GLINE(C:TCanvas; mode,x1,y1,x2,y2:Integer);
var
	i : Integer ;
begin
	if (mode = 0) then begin
		with C do begin
	      Pen.Mode  := pmCopy ;
   		MoveTo(x1,y1);
      	LineTo(x2,y2);
	   end;
   end
   else if (mode = 1) then begin
		i := GetBkMode(hdcMeta);
		SetBkMode(hdcMeta, TRANSPARENT);
		Windows.MoveToEx(hdcMeta, x1,y1,nil);
      Windows.LineTo(hdcMeta, x2,y2);
		SetBkMode(hdcMeta, i);
   end;
end;

{ `` }
{		x1,y1 : Jn_ }
{		x2,y2 : I_ }
procedure GBOX(C:TCanvas; mode,x1,y1,x2,y2:Integer);
var
	i : Integer ;
begin
	if (mode = 0) then begin
		with C do begin
	      Pen.Mode  := pmCopy ;
   		Rectangle(x1,y1,x2,y2);
		end;
   end
   else if (mode = 1) then begin
		i := GetBkMode(hdcMeta);
      SetBkMode(hdcMeta, TRANSPARENT);
		Windows.Rectangle(hdcMeta, x1,y1,x2,y2);
      SetBkMode(hdcMeta, i);
   end;
end;

{ ~` }
{		x1,y1 : Jn_ }
{		x2,y2 : I_ }
procedure GCIRC(C:TCanvas; mode,x1,y1,x2,y2:Integer);
var
	i : Integer ;
begin
	if (mode = 0) then begin
		with C do begin
	      Pen.Mode  := pmCopy ;
			Ellipse(x1,y1,x2,y2);
	   end;
   end
   else if (mode = 1) then begin
		i := GetBkMode(hdcMeta);
		SetBkMode(hdcMeta, TRANSPARENT);
		Windows.Ellipse(hdcMeta,x1,y1,x2,y2);
		SetBkMode(hdcMeta, i);
   end;
end;

{ o^vfS` }
procedure GALL(C:TCanvas;mode,px,py:Integer);
var
	dpi1,dpi2 : Integer ;
	w1,w2 : double ;
   R: TRect ;
   i,i0,i1,i2: Integer;
	p1,p2,p3,p4 : Integer ;
begin
	if (mode = 0) then
		GCLS(C,px,py)
   else if (mode = 1) then begin
		hdcRef := GETDC(0);
		SetMapMode(hdcRef, MM_TEXT);
   	dpi1 := GetDeviceCaps(hdcRef, LOGPIXELSX) ;
	   dpi2 := GetDeviceCaps(hdcRef, LOGPIXELSY) ;
		w1 := 2540.0 / dpi1 ;
	   w2 := 2540.0 / dpi2 ;
   	R := Rect(0,0, Integer(Trunc(px*w1)),Integer(Trunc(py*w2)));
      hdcMeta := CreateEnhMetaFile(hdcRef,nil,@R,'picdata');
	   hdrPrev := SelectObject(hdcMeta, GetStockObject(WHITE_PEN));
	   brsPrev := SelectObject(hdcMeta, GetStockObject(WHITE_BRUSH));
		Windows.Rectangle(hdcMeta, 0,0,px,py);
	   SelectObject(hdcMeta, GetStockObject(NULL_BRUSH));
   end;

	for i:=0 to (Pic_N-1) do begin
     	i0 := Pic[i].cod ;
     	i1 := Pic[i].col ;
     	i2 := Pic[i].typ ;
     	p1 := Pic[i].x1 ;
     	p2 := Pic[i].y1 ;
     	p3 := Pic[i].x2 ;
     	p4 := Pic[i].y2 ;
      GPEN(C,mode,i1,i2);
      case (i0) of
      1:	GLINE(C,mode,p1,p2,p3,p4);
      2:	GBOX (C,mode,p1,p2,p3,p4);
      3:	GCIRC(C,mode,p1,p2,p3,p4);
		end;
   end;

   if (mode = 1) then begin
	   DeleteObject(pen);
		SelectObject(hdcMeta, hdrPrev);
		SelectObject(hdcMeta, brsPrev);
		hmf := CloseEnhMetaFile(hdcMeta);
   end;
end;

{ o^vfS` }
procedure EMFEND ;
begin
   ReleaseDC(0, hdcRef);
end;

end.
